require 'test_helper'
require 'five_leaves/prime_util'

class PrimeUtilTest < MiniTest::Unit::TestCase
  def test_small_factors_skips_factors_above_sqrt
    assert_equal [2, 1], FiveLeaves.small_factors(6)
    assert_equal [2, 1], FiveLeaves.small_factors(14)
  end

  def test_factors_finds_all_factors
    assert_equal [6, 3, 2, 1], FiveLeaves.factors(6)
    assert_equal [9, 3, 1], FiveLeaves.factors(9)
    assert_equal [14, 7, 2, 1], FiveLeaves.factors(14)
    assert_equal [25, 5, 1], FiveLeaves.factors(25)
  end

  def test_proper_factors
    assert_equal [], FiveLeaves.proper_factors(1)
    assert_equal [1], FiveLeaves.proper_factors(2)
    assert_equal [3, 2, 1], FiveLeaves.proper_factors(6)
    assert_equal [3, 1], FiveLeaves.proper_factors(9)
    assert_equal [7, 2, 1], FiveLeaves.proper_factors(14)
    assert_equal [5, 1], FiveLeaves.proper_factors(25)
  end

  def test_prime_factors_finds_all_prime_factors
    assert_equal [3, 2], FiveLeaves.prime_factors(6)
    assert_equal [7, 2], FiveLeaves.prime_factors(14)
    assert_equal [5], FiveLeaves.prime_factors(25)
    assert_equal [7, 2], FiveLeaves.prime_factors(28)
  end
end








